<?php
/**
 * Card Not Present Test Account
 * API Login ID: 2Jfv4PZ6WgPG
 * Transaction Key: 9C8Dc46mqtf9BA6D
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgEmeraldAuthorize extends JPlugin
{

	var $_db = null;

	function plgEmeraldAuthorize(& $subject, $config)
	{
		$this->_db = JFactory::getDBO();
		parent::__construct($subject, $config);
	}

	function onReceivePayment(&$post)
	{
		if($post['processor'] != 'authorize') return 0;
		
		$this->_log("Receive POST", $post);

		if(!empty($post['params']))
		{
			$p = json_decode($post['params'], true);
			$params = new JRegistry($p['params']);
		}
		else
		{
			$params = $this->params;
		}
		
		$user = JFactory::getUser($post['x_cust_id']);
		
		$out['sid'] = $post['order_id'];
		$out['gateway'] = 'Authorize.net';
		$out['price'] = $post['x_amount'];
		$out['pay'] = 'fail';
		$out['user_id'] = $post['x_cust_id'];
		$out['gateway_id'] = $post['x_trans_id'];

		$md5 = md5($params->get('md5hash').$params->get('x_login').$out['gateway_id'].$out['price']);
		if(strtoupper($md5) != $post['x_MD5_Hash']) {
			$this->_log("Does not match", array($params->get('md5hash'), $params->get('x_login')));
			return false;
		}

		if($post['x_response_code'] == 3)
		{
			$this->_log("Error", $post['x_response_reason_text']);
			return false;
		}

		if((int)$post['x_response_code'] == 1)
		{
			$out['pay'] = 'success';
		}

		$this->_log("Return OUT", $out);

		return $out;

	}

	public function onSendPayment($post)
	{
		if($post['processor'] != 'authorize') return false;
		$user = JFactory::getUser();
		$params = new JRegistry($post['params']);

		$transaction_key = $params->get('params.transaction', $this->params->get('transaction'));

		$param['x_fp_sequence'] = $post['order_id'].time();
		$param['x_fp_timestamp'] = time();
		$param['x_amount'] = $post['order_amount'];
		$param['x_login'] = $params->get('params.x_login', $this->params->get('x_login'));
		$param['x_test_request'] = $params->get('params.x_test_request', $this->params->get('x_test_request'));

		$hash = $param['x_login'] . "^" . $param['x_fp_sequence'] . "^" . $param['x_fp_timestamp'] . "^" . $param['x_amount'] . "^";

		if (function_exists('hash_hmac')) {
			$param['x_fp_hash'] = hash_hmac("md5", $hash, $transaction_key);
		}
		else
		{
			$param['x_fp_hash'] = bin2hex(mhash(MHASH_MD5, $hash, $transaction_key));
		}
		$param['x_show_form'] = 'PAYMENT_FORM';
		$param['x_method'] = 'CC';
		$param['x_email'] = $user->get('email');
		$param['x_cust_id'] = $user->get('id');
		$param['x_description'] = $post['order_title'];
		$param['x_version'] = '3.1';

		$param['x_relay_url'] = JURI::base() . 'index.php?option=com_emerald&task=plans.create&processor=authorize&lang=en&order_id='.$post['order_id'];
		$param['x_relay_response'] = 'TRUE';
		$param['x_relay_always'] = 'TRUE';
		$param['x_receipt_link_method'] = 'LINK';
		$param['x_receipt_link_text'] = JText::_('EM_AUTHORIZE_RETRNTOWEBSITE');
		$param['x_receipt_link_url'] = JRoute::_('index.php?option=com_emerald&view=plans&layout=history');

		$url = 'https://secure.authorize.net/gateway/transact.dll?' . $this->_url($param);
		if($params->get('params.x_test_request', $this->params->get('x_test_request')) == 1)
		{
			$url = 'https://test.authorize.net/gateway/transact.dll?' . $this->_url($param);
		}

		header("location: $url");
	}

	public function onAfterReceivePayment($params, $payment)
	{
		if($params['processor'] != 'authorize') return false;
		JFactory::getApplication()->close();
	}

	private function _url($param)
	{
		foreach($param as $k => $v)
		{
			$out[] = "$k=".urlencode($v);
		}
		return implode('&', $out);
	}

	private function _log($text, $addition = null)
	{
		if(!$this->params->get('log')) return;
		if(is_array($addition))
		{
			$addition = print_r($addition, true);
		}
		error_log($text.': '.$addition, 3, JPATH_ROOT."/logs/authorize.log");
	}
}

?>